# all files / Github/bpmn-js/lib/ Modeler.js

100% Statements 25/25
100% Branches 2/2
100% Functions 6/6
100% Lines 25/25

    1
    2
    3
    4
    5
    6
    7
    8
    9
    10
    11
    12
    13
    14
    15
    16
    17
    18
    19
    20
    21
    22
    23
    24
    25
    26
    27
    28
    29
    30
    31
    32
    33
    34
    35
    36
    37
    38
    39
    40
    41
    42
    43
    44
    45
    46
    47
    48
    49
    50
    51
    52
    53
    54
    55
    56
    57
    58
    59
    60
    61
    62
    63
    64
    65
    66
    67
    68
    69
    70
    71
    72
    73
    74
    75
    76
    77
    78
    79
    80
    81
    82
    83
    84
    85
    86
    87
    88
    89
    90
    91
    92
    93
    94
    95
    96
    97
    98
    99
    100
    101
    102
    103
    104
    105
    106
    107
    108
    109
    110
    111
    112
    113
    114
    115
    116
    117
    118
    119
    120
    121
    122
    123
    124
    125
    126
    127
    128
    129
    130
    131
    132
    133
    134
    135
    136
    137
    138
    139
    140
    141
    142
    143
    144
    145
    146
    147
    148
    149
    150
    151
    152
    153
    154
    155
    156
    157
    158
    159
    160
    161
    162
    163
    164
    165
    166
    167
    168
    169
    170
    171
    172
    173
    174
    175
    176
    177
    178
    179
    180
    181
    182
    183
    184
    185
    186
    187
    188
    189
    190
    191
    192
    193
    194
    195
    196
    197
    198
    199
    200
    201
    202
    203
    204
    205
    206
    207
    208
    209
    210
    211
    212
    213
    214
    215
    216
    217
    218
    219
    220
    221
    222
    223
    224
    225
    226
    227
    228
    229
    230
    231
    232
    233
    234
    235
    236
    237
    238
    239
    240
    241
    242
    243
    244
    245
    246

    1×

    1118×

    1118×
    1119×
    1118×

    1118×
    1088×

    1×

    1×
    1×

    1×
    2×

    1×
    1118×

    1118×

    1118×

    1×

    1118×
    1118×

    1118×

    1118×
    30513×

    1×

    1×

    1×

     import inherits from 'inherits';

    import Ids from 'ids';

    import Viewer from './Viewer';

    import NavigatedViewer from './NavigatedViewer';

    import KeyboardMoveModule from 'diagram-js/lib/navigation/keyboard-move';
    import MoveCanvasModule from 'diagram-js/lib/navigation/movecanvas';
    import TouchModule from 'diagram-js/lib/navigation/touch';
    import ZoomScrollModule from 'diagram-js/lib/navigation/zoomscroll';
    import CursorDebug from 'diagram-js-cursor-debug';

    import AlignElementsModule from 'diagram-js/lib/features/align-elements';
    import AutoPlaceModule from './features/auto-place';
    import AutoResizeModule from './features/auto-resize';
    import AutoScrollModule from 'diagram-js/lib/features/auto-scroll';
    import BendpointsModule from 'diagram-js/lib/features/bendpoints';
    import ConnectModule from 'diagram-js/lib/features/connect';
    import ConnectionPreviewModule from 'diagram-js/lib/features/connection-preview';
    import ContextPadModule from './features/context-pad';
    import CopyPasteModule from './features/copy-paste';
    import CreateModule from 'diagram-js/lib/features/create';
    import DistributeElementsModule from './features/distribute-elements';
    import EditorActionsModule from './features/editor-actions';
    import GridSnappingModule from './features/grid-snapping';
    import KeyboardModule from './features/keyboard';
    import KeyboardMoveSelectionModule from 'diagram-js/lib/features/keyboard-move-selection';
    import LabelEditingModule from './features/label-editing';
    import ModelingModule from './features/modeling';
    import MoveModule from 'diagram-js/lib/features/move';
    import PaletteModule from './features/palette';
    import ReplacePreviewModule from './features/replace-preview';
    import ResizeModule from 'diagram-js/lib/features/resize';
    import SnappingModule from './features/snapping';
    import SearchModule from './features/search';

    var initialDiagram =
      '<?xml version="1.0" encoding="UTF-8"?>' +
      '<bpmn:definitions xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ' +
                        'xmlns:bpmn="http://www.omg.org/spec/BPMN/20100524/MODEL" ' +
                        'xmlns:bpmndi="http://www.omg.org/spec/BPMN/20100524/DI" ' +
                        'xmlns:dc="http://www.omg.org/spec/DD/20100524/DC" ' +
                        'targetNamespace="http://bpmn.io/schema/bpmn" ' +
                        'id="Definitions_1">' +
        '<bpmn:process id="Process_1" isExecutable="false">' +
          '<bpmn:startEvent id="StartEvent_1"/>' +
        '</bpmn:process>' +
        '<bpmndi:BPMNDiagram id="BPMNDiagram_1">' +
          '<bpmndi:BPMNPlane id="BPMNPlane_1" bpmnElement="Process_1">' +
            '<bpmndi:BPMNShape id="_BPMNShape_StartEvent_2" bpmnElement="StartEvent_1">' +
              '<dc:Bounds height="36.0" width="36.0" x="173.0" y="102.0"/>' +
            '</bpmndi:BPMNShape>' +
          '</bpmndi:BPMNPlane>' +
        '</bpmndi:BPMNDiagram>' +
      '</bpmn:definitions>';

    /**
     * A modeler for BPMN 2.0 diagrams.
     *
     *
     * ## Extending the Modeler
     *
     * In order to extend the viewer pass extension modules to bootstrap via the
     * `additionalModules` option. An extension module is an object that exposes
     * named services.
     *
     * The following example depicts the integration of a simple
     * logging component that integrates with interaction events:
     *
     *
     * ```javascript
     *
     * // logging component
     * function InteractionLogger(eventBus) {
     *   eventBus.on('element.hover', function(event) {
     *     console.log()
     *   })
     * }
     *
     * InteractionLogger.$inject = [ 'eventBus' ]; // minification save
     *
     * // extension module
     * var extensionModule = {
     *   __init__: [ 'interactionLogger' ],
     *   interactionLogger: [ 'type', InteractionLogger ]
     * };
     *
     * // extend the viewer
     * var bpmnModeler = new Modeler({ additionalModules: [ extensionModule ] });
     * bpmnModeler.importXML(...);
     * ```
     *
     *
     * ## Customizing / Replacing Components
     *
     * You can replace individual diagram components by redefining them in override modules.
     * This works for all components, including those defined in the core.
     *
     * Pass in override modules via the `options.additionalModules` flag like this:
     *
     * ```javascript
     * function CustomContextPadProvider(contextPad) {
     *
     *   contextPad.registerProvider(this);
     *
     *   this.getContextPadEntries = function(element) {
     *     // no entries, effectively disable the context pad
     *     return {};
     *   };
     * }
     *
     * CustomContextPadProvider.$inject = [ 'contextPad' ];
     *
     * var overrideModule = {
     *   contextPadProvider: [ 'type', CustomContextPadProvider ]
     * };
     *
     * var bpmnModeler = new Modeler({ additionalModules: [ overrideModule ]});
     * ```
     *
     * @param {Object} [options] configuration options to pass to the viewer
     * @param {DOMElement} [options.container] the container to render the viewer in, defaults to body.
     * @param {String|Number} [options.width] the width of the viewer
     * @param {String|Number} [options.height] the height of the viewer
     * @param {Object} [options.moddleExtensions] extension packages to provide
     * @param {Array<didi.Module>} [options.modules] a list of modules to override the default modules
     * @param {Array<didi.Module>} [options.additionalModules] a list of modules to use with the default modules
     */
    export default function Modeler(options) {
      Viewer.call(this, options);

      // hook ID collection into the modeler
      this.on('import.parse.complete', function(event) {
        if (!event.error) {
          this._collectIds(event.definitions, event.context);
        }
      }, this);

      this.on('diagram.destroy', function() {
        this.get('moddle').ids.clear();
      }, this);
    }

    inherits(Modeler, Viewer);

    Modeler.Viewer = Viewer;
    Modeler.NavigatedViewer = NavigatedViewer;

    /**
     * Create a new diagram to start modeling.
     *
     * @param {Function} [done]
     */
    Modeler.prototype.createDiagram = function(done) {
      return this.importXML(initialDiagram, done);
    };

    /**
     * Create a moddle instance, attaching ids to it.
     *
     * @param {Object} options
     */
    Modeler.prototype._createModdle = function(options) {
      var moddle = Viewer.prototype._createModdle.call(this, options);

      // attach ids to moddle to be able to track
      // and validated ids in the BPMN 2.0 XML document
      // tree
      moddle.ids = new Ids([ 32, 36, 1 ]);

      return moddle;
    };

    /**
     * Collect ids processed during parsing of the
     * definitions object.
     *
     * @param {ModdleElement} definitions
     * @param {Context} context
     */
    Modeler.prototype._collectIds = function(definitions, context) {

      var moddle = definitions.$model,
          ids = moddle.ids,
          id;

      // remove references from previous import
      ids.clear();

      for (id in context.elementsById) {
        ids.claim(id, context.elementsById[id]);
      }
    };

    Modeler.prototype._interactionModules = [
      // non-modeling components
      KeyboardMoveModule,
      MoveCanvasModule,
      TouchModule,
      ZoomScrollModule
    ];

    Modeler.prototype._modelingModules = [
      // modeling components
      AlignElementsModule,
      AutoPlaceModule,
      AutoScrollModule,
      AutoResizeModule,
      BendpointsModule,
      ConnectModule,
      ConnectionPreviewModule,
      ContextPadModule,
      CopyPasteModule,
      CreateModule,
      DistributeElementsModule,
      EditorActionsModule,
      GridSnappingModule,
      KeyboardModule,
      KeyboardMoveSelectionModule,
      LabelEditingModule,
      CursorDebug,
      ModelingModule,
      MoveModule,
      PaletteModule,
      ReplacePreviewModule,
      ResizeModule,
      SnappingModule,
      SearchModule
    ];

    // modules the modeler is composed of
    //
    // - viewer modules
    // - interaction modules
    // - modeling modules

    Modeler.prototype._modules = [].concat(
      Modeler.prototype._modules,
      Modeler.prototype._interactionModules,
      Modeler.prototype._modelingModules);